using Edu.Common.Enum;
using Edu.Model.Entity.WeChat;
using Edu.Model.ViewModel.WeChat;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.WeChat
{
    /// <summary>
    /// 企业微信欢迎语仓储层
    /// </summary>
    public class RB_WeChat_WelcomesRepository : BaseRepository<RB_WeChat_Welcomes>
    {
        /// <summary>
        /// 获取分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="count"></param>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_WeChat_Welcomes_ViewModel> GetPageList(int pageIndex,int pageSize,out long count, RB_WeChat_Welcomes_ViewModel demodel)
        {
            DynamicParameters parameters = new DynamicParameters();
            string where = $@" 1=1 and r.{nameof(RB_WeChat_Welcomes_ViewModel.Status)} =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Type)} ={demodel.Type}";
            }
            if (!string.IsNullOrEmpty(demodel.Content))
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Content)} like @Content";
                parameters.Add("Content", "%" + demodel.Content + "%");
            }

            string sql = $@" 
SELECT * From RB_WeChat_Welcomes r
WHERE {where} 
ORDER BY r.Id DESC ";
            return GetPage<RB_WeChat_Welcomes_ViewModel>(pageIndex, pageSize, out count, sql, parameters).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_WeChat_Welcomes_ViewModel> GetList(RB_WeChat_Welcomes_ViewModel demodel)
        {
            DynamicParameters parameters = new DynamicParameters();
            string where = $@" 1=1 and r.{nameof(RB_WeChat_Welcomes_ViewModel.Status)} =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.Id > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Id)} ={demodel.Id}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Type)} ={demodel.Type}";
            }
            if (demodel.UserId > 0)
            {
                where += $@" and (r.UserIds ='-1' or find_in_set('{demodel.UserId}',r.UserIds))";
            }
            if (!string.IsNullOrEmpty(demodel.Content))
            {
                where += $@" and r.{nameof(RB_WeChat_Welcomes_ViewModel.Content)} like @Content";
                parameters.Add("Content", "%" + demodel.Content + "%");
            }

            string sql = $@" 
SELECT * From RB_WeChat_Welcomes r
WHERE {where} 
ORDER BY r.Id DESC ";
            return Get<RB_WeChat_Welcomes_ViewModel>(sql, parameters).ToList();
        }

    }
}
